dnl AC_SEARCH_LIB_PATH(FUNCTION, LIB [, PATH [, VARIABLE-TO-SET
dnl            [, ACTION-IF-NOT-FOUND [, OTHER-LIBRARIES]]]])
dnl Find the path for the library defining FUNC, if it's not already available.
AC_DEFUN(DKH_SEARCH_LIB_PATH,
[AC_PREREQ([2.13])
AC_CACHE_CHECK([for library path for $2], [ac_cv_ldflags_$2],
[ac_ldflags_search_save_LIBS="$LIBS"
ac_cv_ldflags_$2="no"
AC_TRY_LINK_FUNC([$1], [ac_cv_ldflags_$2="none required"])
test "$ac_cv_ldflags_$2" = "no" && for i in $3; do
dnl echo Trying "$i"
LIBS="-L$i -l$2 $6 $ac_ldflags_search_save_LIBS"
dnl echo xLIBSx x"$LIBS"x
AC_TRY_LINK_FUNC([$1],
[ac_cv_ldflags_$2="-L$i -l$2"
break])
done
LIBS="$ac_ldflags_search_save_LIBS"])
dnl echo HERE
dnl echo "$ac_cv_ldflags_$2"
if test "$ac_cv_ldflags_$2" != "no"; then
  test "$ac_cv_ldflags_$2" = "none required" || LIBS="$ac_cv_ldflags_$2 $LIBS"
$4="$ac_cv_ldflags_$2"
AC_SUBST($4)dnl
else :
  $5
fi])

dnl AC_SEARCH_INCLUDE_PATH(HEADER-FILE [, PATH [, VARIABLE-TO-SET
dnl            [, ACTION-IF-NOT-FOUND ]]])
dnl Find the path for the HEADER-FILE, if it's not already available.
AC_DEFUN(DKH_SEARCH_INCLUDE_PATH,
[AC_PREREQ([2.13])
ac_include_search_save_CPPFLAGS="$CPPFLAGS"
ac_safe=`echo "$1" | sed 'y%./+-%__p_%'`
eval "ac_cv_header_$ac_safe=\"no\""
AC_CHECK_HEADER($1, eval "ac_cv_header_$ac_safe=\"none required\"")
eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = \"no\"" && for i in $2; do
AC_MSG_CHECKING([for $1 in $i])
CPPFLAGS="-I$i $ac_include_search_save_CPPFLAGS"
dnl echo xCPPFLAGSx x"$CPPFLAGS"x
AC_TRY_CPP([#include <$1>],
[eval "ac_cv_header_$ac_safe=\"-I$i\""
AC_MSG_RESULT("-I$i")
break],
AC_MSG_RESULT(no)
)
done
CPPFLAGS="$ac_include_search_save_CPPFLAGS"
eval "ac_include_search_result=`echo \\\$ac_cv_header_$ac_safe`"
dnl echo Result is "$ac_include_search_result"
if test "$ac_include_search_result" != "no"; then
  if test "$ac_include_search_result" = "none required"; then
    $3=""
  else
    CPPFLAGS="$ac_include_search_result $CPPFLAGS"
    $3="$ac_include_search_result"
  fi
AC_SUBST($3)dnl
else :
  $4
fi])

dnl #########################################################################
dnl Check for MySQL headers and libraries
dnl #########################################################################
dnl A macro for setting up mysql (ripped from Scott Barron's
dnl <sbarron@vvm.com> mysqltutor package)

AC_DEFUN(AC_PACKAGE_MYSQL,
[
AC_PROVIDE([$0])
AC_REQUIRE_CPP

ac_cv_with_mysql_dir=""
ac_cv_with_mysql_lib=""
ac_cv_with_mysql_inc=""
MYSQL_CFLAGS=""
MYSQL_LIBS=""

dnl command line options and --help descriptions

AC_ARG_WITH(mysql-dir,
    [  --with-mysql-dir           where the root of mysql is installed (/usr/local/mysql)
 ],
    [  ac_cv_with_mysql_dir="$withval" ])

AC_ARG_WITH(mysql-include,
    [  --with-mysql-include       where the mysql headers are. (/usr/local/mysql/include) ],
    [  ac_cv_with_mysql_inc="$withval" ])
    
AC_ARG_WITH(mysql-lib,
    [  --with-mysql-lib           where the mysql library is installed. (/usr/local/mysql/lib)],
    [  ac_cv_with_mysql_lib="$withval" ])

dnl find some paths

AC_MSG_CHECKING("for MySQL directory")

for ac_dir in        		\
        ${ac_cv_with_mysql_dir}	\
	/usr/mysql		\
        /usr/local/mysql   	\
        /usr/share/mysql       	\
        ;                   	\
do
        if test -n "$ac_dir" && test -d "$ac_dir"; then
        ac_cv_with_mysql_dir="$ac_dir" 
                break;
        fi
done

if test ! -n "$ac_cv_with_mysql_dir"; then
        AC_MSG_RESULT("Nonstandard")
else
        AC_MSG_RESULT("$ac_cv_with_mysql_dir")
fi

dnl check for libraries and includes
DKH_SEARCH_INCLUDE_PATH([mysql.h],
[   $ac_cv_with_mysql_dir/include	\
    $ac_cv_with_mysql_inc       	\
    /usr/include/mysql             	\
    /usr/local/include/mysql       	\
    /usr/local/mysql/include       	\
    /usr/local/mysql/include/mysql	\
    /usr/share/mysql/include       	\
    /usr/share/include/mysql       	\
],
[MYSQL_CFLAGS],
AC_MSG_ERROR(["Can\'t find the MySQL headers"])
)

DKH_SEARCH_LIB_PATH(mysql_store_result, mysqlclient, 
[   $ac_cv_with_mysql_dir/lib	\
    $ac_cv_with_mysql_lib   	\
    /usr/lib/mysql \
    /usr/local/lib/mysql \
    /usr/local/mysql/lib \
    /usr/local/mysql/lib/mysql \
    /usr/share/mysql/lib \
    /usr/share/lib/mysql \
], 
[MYSQL_LIBS],
AC_MSG_ERROR(["Can\'t find the libmysqlclient"]),
-lm )
])
