# -*- Mode:rpm-spec -*-
# mysql++.spec.in
Summary: C++ interface to MySQL database
%define rel 1

%define version 1.6.0
%define pkgname mysql++
%define prefix /usr

%define lt_release 1.6
%define lt_version 0.0.0

# This is a hack until I can figure out how to better handle replacing
# autoconf macros... (gotta love autoconf...)
%define __aclocal   aclocal || aclocal -I ./macros
%define configure_args  

Name: %{pkgname}
Version: %{version}
Release: %{rel}

Copyright: LGPL
Group: Applications/Databases
Source: %{pkgname}-%{version}.tar.gz
Requires: MySQL-server
Buildroot: /tmp/%{pkgname}-root
URL: http://mysql.com
Prefix: %{prefix}
BuildArchitectures: i586
Packager: Dale K. Hawkins <dhawkins@cdrgts.com>

%description
A C++ interface to the MySQL API.

%changelog
* Thu Feb  3 2000 Dale Hawkins <dhawkins@cdrgts.com>

- Changed __aclocal definition to be more "forgiving"

* Sat Jan  8 2000 Dale Hawkins <dhawkins@cdrgts.com>

- added mysql-config and .m4 files
- Use RPM_RELEASE as set by autoconf

* Fri Jan  7 2000 Dale Hawkins <dhawkins@cdrgts.com>

- Fixed header file inclusion

* Tue Jan  4 2000 Dale Hawkins <dhawkins@cdrgts.com>

- Added a spec.in file to work with autoconf and to support libtool's release mechanism

%prep
%setup
#%patch

%build
%GNUconfigure %{configure_args}
# This is why we copy the CFLAGS to the CXXFLAGS in configure.in
# CFLAGS="%{optflags}" CXXFLAGS="%{optflags}" ./configure %{_target_platform} --prefix=%{prefix}
make

%install
# To make things work with BUILDROOT
if [ "$RPM_BUILD_ROOT" != "/tmp/%{pkgname}-root" ]
then
  echo
  echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  echo @								    @
  echo @  RPM_BUILD_ROOT is not what I expected.  Please clean it yourself. @
  echo @								    @
  echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  echo
else
  echo Cleaning RPM_BUILD_ROOT: "$RPM_BUILD_ROOT"
  rm -rf "$RPM_BUILD_ROOT"
fi
make DESTDIR="$RPM_BUILD_ROOT" install

%clean
# Call me paranoid, but I do not want to be responsible for nuking
# someone's harddrive!
if [ "$RPM_BUILD_ROOT" != "/tmp/%{pkgname}-root" ]
then
  echo
  echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  echo @								    @
  echo @  RPM_BUILD_ROOT is not what I expected.  Please clean it yourself. @
  echo @								    @
  echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  echo
else
  echo Cleaning RPM_BUILD_ROOT: "$RPM_BUILD_ROOT"
  rm -rf "$RPM_BUILD_ROOT"
fi

%files
%defattr(-, root, root)
%{prefix}/lib/lib*.so*
%doc COPYRIGHT ChangeLog README AUTHORS NEWS
%doc doc/*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%package devel
Summary: Development files for %{pkgname}
Group: Applications/Databases
%description devel
Development files for %{pkgname}.

%files devel
%defattr(-, root, root)
%{prefix}/lib/lib*.so
%{prefix}/lib/*a
%attr(0755, root, root) %{prefix}/bin/%{pkgname}-config
%attr(0755, root, root) %{prefix}/bin/mysql-config
%{prefix}/include/%{pkgname}
%{prefix}/share/aclocal/*.m4
# IMHO, the examples should be installed as well
%doc examples/*.cc
%doc examples/*.hh
# Not to mention the real documentation
%doc doc
